/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.kernel;

import org.javafmi.modeldescription.FmiVersion;
import org.javafmi.modeldescription.ModelDescription;
import org.javafmi.modeldescription.ScalarVariable;

public interface FmuProxy {

    void instantiate(double timeout);

    Status initialize(double startTime, double stopTime);

    Status doStep(double communicationPoint, double stepSize);

    Status cancelStep();

    Status terminate();

    void freeInstance();

    Status reset();

    ModelDescription getModelDescription();

    FmiVersion getVersion();

    double[] getReal(int... valueReference);

    int getInteger(Integer valueReference);

    boolean getBoolean(Integer valueReference);

    String getString(Integer valueReference);

    Object getEnumeration(ScalarVariable modelVariable);

    Status setReal(int[] valueReference, double[] doubleValue);

    Status setInteger(Integer valueReference, Integer intValue);

    Status setBoolean(Integer valueReference, Boolean booleanValue);

    Status setString(Integer valueReference, String stringValue);

    boolean isTerminated();

    void setTolerance(double simulationTolerance);
}
