/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.kernel.v2.nativeaccess;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;

import java.util.Arrays;
import java.util.List;

public class CallbackFunctions extends Structure {

    public FmiV2Interface.Logger logger;
    public FmiV2Interface.AllocateMemory allocateMemory;
    public FmiV2Interface.FreeMemory freeMemory;
    public FmiV2Interface.StepFinished stepFinished;
    public Pointer componentEnvironment;

    public CallbackFunctions(List<Object> onMemoryAllocatedObjects) {
        super();
        this.logger = new Logger();
        this.allocateMemory = new AllocateMemory(onMemoryAllocatedObjects);
        this.freeMemory = new FreeMemory(onMemoryAllocatedObjects);
        this.stepFinished = new StepFinished();
        this.componentEnvironment = null;
    }

    @Override
    protected List getFieldOrder() {
        return Arrays.asList("logger", "allocateMemory", "freeMemory", "stepFinished", "componentEnvironment");
    }
}
