/*

 Copyright 2013, 2014 SIANI - ULPGC
 Jose Juan Hernandez Cabrera
 Jose Evora Gomez
 Johan Sebastian Cortes Montenegro

 This File is Part of JavaFMI Project

 JavaFMI Project is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 JavaFMI Project is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with JavaFMI Library.  If not, see <http://www.gnu.org/licenses/>.

 */
package org.javafmi.modeldescription.v2;

import org.simpleframework.xml.Attribute;
import org.simpleframework.xml.Root;

@Root(strict = false)
public class RealType extends SimpleType {

    public static final String REAL_TYPE = "Real";
    @Attribute(required = false)
    private String declaredType;
    @Attribute(required = false)
    private String quantity;
    @Attribute(required = false)
    private String unit;
    @Attribute(required = false)
    private String displayUnit;
    @Attribute(required = false)
    private boolean relativeQuantity;
    @Attribute(required = false)
    private double min;
    @Attribute(required = false)
    private double max;
    @Attribute(required = false)
    private double nominal;
    @Attribute(required = false)
    private boolean unbounded;
    @Attribute(required = false)
    private double start;
    @Attribute(required = false)
    private int derivative;
    @Attribute(required = false)
    private boolean reinit;

    public RealType() {
        this.declaredType = REAL_TYPE;
    }

    @Override
    public boolean equals(Object o) {
        if(this == o) return true;
        if(!(o instanceof RealType)) return false;
        RealType realType = (RealType) o;
        return declaredType.equals(realType.declaredType);
    }

    @Override
    public int hashCode() {
        return declaredType.hashCode();
    }

    public String getDeclaredType() {
        return declaredType;
    }

    public void setDeclaredType(String declaredType) {
        this.declaredType = declaredType;
    }

    public String getQuantity() {
        return quantity;
    }

    public void setQuantity(String quantity) {
        this.quantity = quantity;
    }

    public String getUnit() {
        return unit;
    }

    public void setUnit(String unit) {
        this.unit = unit;
    }

    public String getDisplayUnit() {
        return displayUnit;
    }

    public void setDisplayUnit(String displayUnit) {
        this.displayUnit = displayUnit;
    }

    public boolean isRelativeQuantity() {
        return relativeQuantity;
    }

    public void setRelativeQuantity(boolean relativeQuantity) {
        this.relativeQuantity = relativeQuantity;
    }

    public double getMin() {
        return min;
    }

    public void setMin(double min) {
        this.min = min;
    }

    public double getMax() {
        return max;
    }

    public void setMax(double max) {
        this.max = max;
    }

    public double getNominal() {
        return nominal;
    }

    public void setNominal(double nominal) {
        this.nominal = nominal;
    }

    public boolean isUnbounded() {
        return unbounded;
    }

    public void setUnbounded(boolean unbounded) {
        this.unbounded = unbounded;
    }

    public double getStart() {
        return start;
    }

    public void setStart(double start) {
        this.start = start;
    }

    public int getDerivative() {
        return derivative;
    }

    public void setDerivative(int derivative) {
        this.derivative = derivative;
    }

    public boolean isReinit() {
        return reinit;
    }

    public void setReinit(boolean reinit) {
        this.reinit = reinit;
    }
}
